# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`dhcp`](#dhcp): A selector for configuring the DHCP server or client
* [`dhcp::dhcpd`](#dhcp--dhcpd): This class is used to start dhcpd and create dhcpd.conf

## Classes

### <a name="dhcp"></a>`dhcp`

The client portion has not yet been implemented.

#### Parameters

The following parameters are available in the `dhcp` class:

* [`is_client`](#-dhcp--is_client)
* [`is_server`](#-dhcp--is_server)

##### <a name="-dhcp--is_client"></a>`is_client`

Data type: `Boolean`

Not yet implemented

Default value: `false`

##### <a name="-dhcp--is_server"></a>`is_server`

Data type: `Boolean`

Denotes that the system is a DHCP server

Default value: `true`

### <a name="dhcp--dhcpd"></a>`dhcp::dhcpd`

This class is used to start dhcpd and create dhcpd.conf

#### Parameters

The following parameters are available in the `dhcp::dhcpd` class:

* [`package_name`](#-dhcp--dhcpd--package_name)
* [`enable_data_rsync`](#-dhcp--dhcpd--enable_data_rsync)
* [`rsync_server`](#-dhcp--dhcpd--rsync_server)
* [`rsync_timeout`](#-dhcp--dhcpd--rsync_timeout)
* [`dhcpd_conf`](#-dhcp--dhcpd--dhcpd_conf)
* [`firewall`](#-dhcp--dhcpd--firewall)
* [`logrotate`](#-dhcp--dhcpd--logrotate)
* [`syslog`](#-dhcp--dhcpd--syslog)
* [`package_ensure`](#-dhcp--dhcpd--package_ensure)
* [`rsync_source`](#-dhcp--dhcpd--rsync_source)

##### <a name="-dhcp--dhcpd--package_name"></a>`package_name`

Data type: `String[1]`

The DHCP server package name

##### <a name="-dhcp--dhcpd--enable_data_rsync"></a>`enable_data_rsync`

Data type: `Boolean`

Enable the retrieval of the DHCP configuration from an rsync server

* NOTE: This will be disabled by default at some point in the future

Default value: `true`

##### <a name="-dhcp--dhcpd--rsync_server"></a>`rsync_server`

Data type: `String[1]`

The address of the server from which to pull the DHCPD
configuration

Default value: `simplib::lookup('simp_options::rsync::server', { 'default_value' => '127.0.0.1' })`

##### <a name="-dhcp--dhcpd--rsync_timeout"></a>`rsync_timeout`

Data type:

```puppet
Variant[
    Integer[0],
    Pattern[/\A\d+\z/]
  ]
```

The connection timeout when communicating with the rsync server

Default value: `simplib::lookup('simp_options::rsync::timeout', { 'default_value' => '2' })`

##### <a name="-dhcp--dhcpd--dhcpd_conf"></a>`dhcpd_conf`

Data type: `Optional[String[1]]`

The entire contents of the /etc/dhcpd.conf configuration file

* If this is set, `$enable_data_rsync` will be forced to `false`

Default value: `undef`

##### <a name="-dhcp--dhcpd--firewall"></a>`firewall`

Data type: `Boolean`

Whether or not to include the SIMP iptables class

Default value: `simplib::lookup('simp_options::firewall', { 'default_value' => false })`

##### <a name="-dhcp--dhcpd--logrotate"></a>`logrotate`

Data type: `Boolean`

Whether or not to include the SIMP logrotate class

Default value: `simplib::lookup('simp_options::logrotate', { 'default_value' => false })`

##### <a name="-dhcp--dhcpd--syslog"></a>`syslog`

Data type: `Boolean`

Whether or not to include the SIMP rsyslog class

Default value: `simplib::lookup('simp_options::syslog', { 'default_value' => false })`

##### <a name="-dhcp--dhcpd--package_ensure"></a>`package_ensure`

Data type: `String[1]`

The ensure status of the dhcp package

Default value: `simplib::lookup('simp_options::package_ensure', { 'default_value' => 'installed' })`

##### <a name="-dhcp--dhcpd--rsync_source"></a>`rsync_source`

Data type: `String[1]`



Default value: `"dhcpd_${facts['environment']}_${facts['os']['name']}/dhcpd.conf"`

